org.apache.poi.hwpf.converter

## Class AbstractWordConverter

- java.lang.Object
- - org.apache.poi.hwpf.converter.AbstractWordConverter

- Direct Known Subclasses:
    WordToFoConverter, WordToHtmlConverter, WordToTextConverter

      @Beta
      public abstract class AbstractWordConverter
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static char` | `UNICODECHAR_NO_BREAK_SPACE`
    `protected static char` | `UNICODECHAR_NONBREAKING_HYPHEN`
    `protected static char` | `UNICODECHAR_ZERO_WIDTH_SPACE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractWordConverter()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `afterProcess()` Special actions that need to be called after processing complete, like updating stylesheets or building document notes list.
    `protected FontReplacer.Triplet` | `getCharacterRunTriplet(CharacterRun characterRun)`
    `abstract org.w3c.dom.Document` | `getDocument()`
    `FontReplacer` | `getFontReplacer()`
    `protected int` | `getNumberColumnsSpanned(int[] tableCellEdges, int currentEdgeIndex, TableCell tableCell)`
    `protected int` | `getNumberRowsSpanned(Table table, int[] tableCellEdges, int currentRowIndex, int currentColumnIndex, TableCell tableCell)`
    `PicturesManager` | `getPicturesManager()`
    `protected abstract void` | `outputCharacters(org.w3c.dom.Element block, CharacterRun characterRun, java.lang.String text)`
    `protected abstract void` | `processBookmarks(HWPFDocumentCore wordDocument, org.w3c.dom.Element currentBlock, Range range, int currentTableLevel, java.util.List<Bookmark> rangeBookmarks)` Wrap range into bookmark(s) and process it.
    `protected boolean` | `processCharacters(HWPFDocumentCore wordDocument, int currentTableLevel, Range range, org.w3c.dom.Element block)`
    `protected void` | `processDeadField(HWPFDocumentCore wordDocument, org.w3c.dom.Element currentBlock, Range range, int currentTableLevel, int beginMark, int separatorMark, int endMark)`
    `void` | `processDocument(HWPFDocumentCore wordDocument)`
    `protected abstract void` | `processDocumentInformation(SummaryInformation summaryInformation)`
    `protected void` | `processDocumentPart(HWPFDocumentCore wordDocument, Range range)`
    `protected void` | `processDrawnObject(HWPFDocument doc, CharacterRun characterRun, org.w3c.dom.Element block)`
    `protected abstract void` | `processDrawnObject(HWPFDocument doc, CharacterRun characterRun, OfficeDrawing officeDrawing, java.lang.String path, org.w3c.dom.Element block)`
    `protected void` | `processDropDownList(org.w3c.dom.Element block, CharacterRun characterRun, java.lang.String[] values, int defaultIndex)`
    `protected abstract void` | `processEndnoteAutonumbered(HWPFDocument wordDocument, int noteIndex, org.w3c.dom.Element block, Range endnoteTextRange)`
    `protected void` | `processField(HWPFDocument wordDocument, Range parentRange, int currentTableLevel, Field field, org.w3c.dom.Element currentBlock)`
    `protected abstract void` | `processFootnoteAutonumbered(HWPFDocument wordDocument, int noteIndex, org.w3c.dom.Element block, Range footnoteTextRange)`
    `protected abstract void` | `processHyperlink(HWPFDocumentCore wordDocument, org.w3c.dom.Element currentBlock, Range textRange, int currentTableLevel, java.lang.String hyperlink)`
    `protected void` | `processImage(org.w3c.dom.Element currentBlock, boolean inlined, Picture picture)`
    `protected abstract void` | `processImage(org.w3c.dom.Element currentBlock, boolean inlined, Picture picture, java.lang.String url)`
    `protected abstract void` | `processImageWithoutPicturesManager(org.w3c.dom.Element currentBlock, boolean inlined, Picture picture)`
    `protected abstract void` | `processLineBreak(org.w3c.dom.Element block, CharacterRun characterRun)`
    `protected void` | `processNoteAnchor(HWPFDocument doc, CharacterRun characterRun, org.w3c.dom.Element block)`
    `protected boolean` | `processOle2(HWPFDocument wordDocument, org.w3c.dom.Element block, Entry entry)`
    `protected abstract void` | `processPageBreak(HWPFDocumentCore wordDocument, org.w3c.dom.Element flow)`
    `protected abstract void` | `processPageref(HWPFDocumentCore wordDocument, org.w3c.dom.Element currentBlock, Range textRange, int currentTableLevel, java.lang.String pageref)`
    `protected abstract void` | `processParagraph(HWPFDocumentCore wordDocument, org.w3c.dom.Element parentElement, int currentTableLevel, Paragraph paragraph, java.lang.String bulletText)`
    `protected void` | `processParagraphes(HWPFDocumentCore wordDocument, org.w3c.dom.Element flow, Range range, int currentTableLevel)`
    `protected abstract void` | `processSection(HWPFDocumentCore wordDocument, Section section, int s)`
    `protected void` | `processSingleSection(HWPFDocumentCore wordDocument, Section section)`
    `protected void` | `processSymbol(HWPFDocument doc, CharacterRun characterRun, org.w3c.dom.Element block)`
    `protected abstract void` | `processTable(HWPFDocumentCore wordDocument, org.w3c.dom.Element flow, Table table)`
    `void` | `setFontReplacer(FontReplacer fontReplacer)`
    `void` | `setPicturesManager(PicturesManager fileManager)`
    `protected int` | `tryDeadField(HWPFDocumentCore wordDocument, Range range, int currentTableLevel, int beginMark, org.w3c.dom.Element currentBlock)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### UNICODECHAR_NO_BREAK_SPACE

          protected static final char UNICODECHAR_NO_BREAK_SPACE

      See Also:
        Constant Field Values

    - #### UNICODECHAR_NONBREAKING_HYPHEN

          protected static final char UNICODECHAR_NONBREAKING_HYPHEN

      See Also:
        Constant Field Values

    - #### UNICODECHAR_ZERO_WIDTH_SPACE

          protected static final char UNICODECHAR_ZERO_WIDTH_SPACE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AbstractWordConverter

          public AbstractWordConverter()

  - ### Method Detail

    - #### afterProcess

          protected void afterProcess()

      Special actions that need to be called after processing complete, like updating stylesheets or building document notes list. Usually they are called once, but it's okay to call them several times.

    - #### getCharacterRunTriplet

          protected FontReplacer.Triplet getCharacterRunTriplet(CharacterRun characterRun)

    - #### getDocument

          public abstract org.w3c.dom.Document getDocument()

    - #### getFontReplacer

          public FontReplacer getFontReplacer()

    - #### getNumberColumnsSpanned

          protected int getNumberColumnsSpanned(int[] tableCellEdges,
                                                int currentEdgeIndex,
                                                TableCell tableCell)

    - #### getNumberRowsSpanned

          protected int getNumberRowsSpanned(Table table,
                                             int[] tableCellEdges,
                                             int currentRowIndex,
                                             int currentColumnIndex,
                                             TableCell tableCell)

    - #### getPicturesManager

          public PicturesManager getPicturesManager()

    - #### outputCharacters

          protected abstract void outputCharacters(org.w3c.dom.Element block,
                                                   CharacterRun characterRun,
                                                   java.lang.String text)

    - #### processBookmarks

          protected abstract void processBookmarks(HWPFDocumentCore wordDocument,
                                                   org.w3c.dom.Element currentBlock,
                                                   Range range,
                                                   int currentTableLevel,
                                                   java.util.List<Bookmark> rangeBookmarks)

      Wrap range into bookmark(s) and process it. All bookmarks have starts equal to range start and ends equal to range end. Usually it's only one bookmark.

    - #### processCharacters

          protected boolean processCharacters(HWPFDocumentCore wordDocument,
                                              int currentTableLevel,
                                              Range range,
                                              org.w3c.dom.Element block)

    - #### processDeadField

          protected void processDeadField(HWPFDocumentCore wordDocument,
                                          org.w3c.dom.Element currentBlock,
                                          Range range,
                                          int currentTableLevel,
                                          int beginMark,
                                          int separatorMark,
                                          int endMark)

    - #### processDocument

          public void processDocument(HWPFDocumentCore wordDocument)

    - #### processDocumentInformation

          protected abstract void processDocumentInformation(SummaryInformation summaryInformation)

    - #### processDocumentPart

          protected void processDocumentPart(HWPFDocumentCore wordDocument,
                                             Range range)

    - #### processDrawnObject

          protected void processDrawnObject(HWPFDocument doc,
                                            CharacterRun characterRun,
                                            org.w3c.dom.Element block)

    - #### processDrawnObject

          protected abstract void processDrawnObject(HWPFDocument doc,
                                                     CharacterRun characterRun,
                                                     OfficeDrawing officeDrawing,
                                                     java.lang.String path,
                                                     org.w3c.dom.Element block)

    - #### processDropDownList

          protected void processDropDownList(org.w3c.dom.Element block,
                                             CharacterRun characterRun,
                                             java.lang.String[] values,
                                             int defaultIndex)

    - #### processEndnoteAutonumbered

          protected abstract void processEndnoteAutonumbered(HWPFDocument wordDocument,
                                                             int noteIndex,
                                                             org.w3c.dom.Element block,
                                                             Range endnoteTextRange)

    - #### processField

          protected void processField(HWPFDocument wordDocument,
                                      Range parentRange,
                                      int currentTableLevel,
                                      Field field,
                                      org.w3c.dom.Element currentBlock)

    - #### processFootnoteAutonumbered

          protected abstract void processFootnoteAutonumbered(HWPFDocument wordDocument,
                                                              int noteIndex,
                                                              org.w3c.dom.Element block,
                                                              Range footnoteTextRange)

    - #### processHyperlink

          protected abstract void processHyperlink(HWPFDocumentCore wordDocument,
                                                   org.w3c.dom.Element currentBlock,
                                                   Range textRange,
                                                   int currentTableLevel,
                                                   java.lang.String hyperlink)

    - #### processImage

          protected void processImage(org.w3c.dom.Element currentBlock,
                                      boolean inlined,
                                      Picture picture)

    - #### processImage

          protected abstract void processImage(org.w3c.dom.Element currentBlock,
                                               boolean inlined,
                                               Picture picture,
                                               java.lang.String url)

    - #### processImageWithoutPicturesManager

          @Internal
          protected abstract void processImageWithoutPicturesManager(org.w3c.dom.Element currentBlock,
                                                                               boolean inlined,
                                                                               Picture picture)

    - #### processLineBreak

          protected abstract void processLineBreak(org.w3c.dom.Element block,
                                                   CharacterRun characterRun)

    - #### processNoteAnchor

          protected void processNoteAnchor(HWPFDocument doc,
                                           CharacterRun characterRun,
                                           org.w3c.dom.Element block)

    - #### processOle2

          protected boolean processOle2(HWPFDocument wordDocument,
                                        org.w3c.dom.Element block,
                                        Entry entry)
                                 throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### processPageBreak

          protected abstract void processPageBreak(HWPFDocumentCore wordDocument,
                                                   org.w3c.dom.Element flow)

    - #### processPageref

          protected abstract void processPageref(HWPFDocumentCore wordDocument,
                                                 org.w3c.dom.Element currentBlock,
                                                 Range textRange,
                                                 int currentTableLevel,
                                                 java.lang.String pageref)

    - #### processParagraph

          protected abstract void processParagraph(HWPFDocumentCore wordDocument,
                                                   org.w3c.dom.Element parentElement,
                                                   int currentTableLevel,
                                                   Paragraph paragraph,
                                                   java.lang.String bulletText)

    - #### processParagraphes

          protected void processParagraphes(HWPFDocumentCore wordDocument,
                                            org.w3c.dom.Element flow,
                                            Range range,
                                            int currentTableLevel)

    - #### processSection

          protected abstract void processSection(HWPFDocumentCore wordDocument,
                                                 Section section,
                                                 int s)

    - #### processSingleSection

          protected void processSingleSection(HWPFDocumentCore wordDocument,
                                              Section section)

    - #### processSymbol

          protected void processSymbol(HWPFDocument doc,
                                       CharacterRun characterRun,
                                       org.w3c.dom.Element block)

    - #### processTable

          protected abstract void processTable(HWPFDocumentCore wordDocument,
                                               org.w3c.dom.Element flow,
                                               Table table)

    - #### setFontReplacer

          public void setFontReplacer(FontReplacer fontReplacer)

    - #### setPicturesManager

          public void setPicturesManager(PicturesManager fileManager)

    - #### tryDeadField

          protected int tryDeadField(HWPFDocumentCore wordDocument,
                                     Range range,
                                     int currentTableLevel,
                                     int beginMark,
                                     org.w3c.dom.Element currentBlock)

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.